case exmdb_callid::ping_store: {
	auto r1 = std::make_unique<exresp_ping_store>();
	auto ret = exmdb_server::ping_store(q0->dir);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_all_named_propids: {
	auto r1 = std::make_unique<exresp_get_all_named_propids>();
	auto &r = *r1;
	auto ret = exmdb_server::get_all_named_propids(q0->dir, &r.propids);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_named_propids: {
	auto &q = *static_cast<const exreq_get_named_propids *>(q0);
	auto r1 = std::make_unique<exresp_get_named_propids>();
	auto &r = *r1;
	auto ret = exmdb_server::get_named_propids(q0->dir, q.b_create, q.ppropnames, &r.propids);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_named_propnames: {
	auto &q = *static_cast<const exreq_get_named_propnames *>(q0);
	auto r1 = std::make_unique<exresp_get_named_propnames>();
	auto &r = *r1;
	auto ret = exmdb_server::get_named_propnames(q0->dir, q.ppropids, &r.propnames);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_mapping_guid: {
	auto &q = *static_cast<const exreq_get_mapping_guid *>(q0);
	auto r1 = std::make_unique<exresp_get_mapping_guid>();
	auto &r = *r1;
	auto ret = exmdb_server::get_mapping_guid(q0->dir, q.replid, &r.b_found, &r.guid);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_mapping_replid: {
	auto &q = *static_cast<const exreq_get_mapping_replid *>(q0);
	auto r1 = std::make_unique<exresp_get_mapping_replid>();
	auto &r = *r1;
	auto ret = exmdb_server::get_mapping_replid(q0->dir, q.guid, &r.replid, &r.e_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_store_all_proptags: {
	auto r1 = std::make_unique<exresp_get_store_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_store_all_proptags(q0->dir, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_store_properties: {
	auto &q = *static_cast<const exreq_get_store_properties *>(q0);
	auto r1 = std::make_unique<exresp_get_store_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::get_store_properties(q0->dir, q.cpid, q.pproptags, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_store_properties: {
	auto &q = *static_cast<const exreq_set_store_properties *>(q0);
	auto r1 = std::make_unique<exresp_set_store_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::set_store_properties(q0->dir, q.cpid, q.ppropvals, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::remove_store_properties: {
	auto &q = *static_cast<const exreq_remove_store_properties *>(q0);
	auto r1 = std::make_unique<exresp_remove_store_properties>();
	auto ret = exmdb_server::remove_store_properties(q0->dir, q.pproptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_mbox_perm: {
	auto &q = *static_cast<const exreq_get_mbox_perm *>(q0);
	auto r1 = std::make_unique<exresp_get_mbox_perm>();
	auto &r = *r1;
	auto ret = exmdb_server::get_mbox_perm(q0->dir, q.username, &r.permission);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_by_class: {
	auto &q = *static_cast<const exreq_get_folder_by_class *>(q0);
	auto r1 = std::make_unique<exresp_get_folder_by_class>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_by_class(q0->dir, q.str_class, &r.id, &r.str_explicit);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_folder_by_class: {
	auto &q = *static_cast<const exreq_set_folder_by_class *>(q0);
	auto r1 = std::make_unique<exresp_set_folder_by_class>();
	auto &r = *r1;
	auto ret = exmdb_server::set_folder_by_class(q0->dir, q.folder_id, q.str_class, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_class_table: {
	auto r1 = std::make_unique<exresp_get_folder_class_table>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_class_table(q0->dir, &r.table);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_folder_id: {
	auto &q = *static_cast<const exreq_check_folder_id *>(q0);
	auto r1 = std::make_unique<exresp_check_folder_id>();
	auto &r = *r1;
	auto ret = exmdb_server::check_folder_id(q0->dir, q.folder_id, &r.b_exist);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_folder_deleted: {
	auto &q = *static_cast<const exreq_check_folder_deleted *>(q0);
	auto r1 = std::make_unique<exresp_check_folder_deleted>();
	auto &r = *r1;
	auto ret = exmdb_server::check_folder_deleted(q0->dir, q.folder_id, &r.b_del);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_by_name: {
	auto &q = *static_cast<const exreq_get_folder_by_name *>(q0);
	auto r1 = std::make_unique<exresp_get_folder_by_name>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_by_name(q0->dir, q.parent_id, q.str_name, &r.folder_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_perm: {
	auto &q = *static_cast<const exreq_get_folder_perm *>(q0);
	auto r1 = std::make_unique<exresp_get_folder_perm>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_perm(q0->dir, q.folder_id, q.username, &r.permission);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::create_folder_v1: {
	auto &q = *static_cast<const exreq_create_folder_v1 *>(q0);
	auto r1 = std::make_unique<exresp_create_folder_v1>();
	auto &r = *r1;
	auto ret = exmdb_server::create_folder_v1(q0->dir, q.cpid, q.pproperties, &r.folder_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::create_folder: {
	auto &q = *static_cast<const exreq_create_folder *>(q0);
	auto r1 = std::make_unique<exresp_create_folder>();
	auto &r = *r1;
	auto ret = exmdb_server::create_folder(q0->dir, q.cpid, q.pproperties, &r.folder_id, &r.e_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_all_proptags: {
	auto &q = *static_cast<const exreq_get_folder_all_proptags *>(q0);
	auto r1 = std::make_unique<exresp_get_folder_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_all_proptags(q0->dir, q.folder_id, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_folder_properties: {
	auto &q = *static_cast<const exreq_get_folder_properties *>(q0);
	auto r1 = std::make_unique<exresp_get_folder_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::get_folder_properties(q0->dir, q.cpid, q.folder_id, q.pproptags, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_folder_properties: {
	auto &q = *static_cast<const exreq_set_folder_properties *>(q0);
	auto r1 = std::make_unique<exresp_set_folder_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::set_folder_properties(q0->dir, q.cpid, q.folder_id, q.pproperties, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::remove_folder_properties: {
	auto &q = *static_cast<const exreq_remove_folder_properties *>(q0);
	auto r1 = std::make_unique<exresp_remove_folder_properties>();
	auto ret = exmdb_server::remove_folder_properties(q0->dir, q.folder_id, q.pproptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::delete_folder: {
	auto &q = *static_cast<const exreq_delete_folder *>(q0);
	auto r1 = std::make_unique<exresp_delete_folder>();
	auto &r = *r1;
	auto ret = exmdb_server::delete_folder(q0->dir, q.cpid, q.folder_id, q.b_hard, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::empty_folder: {
	auto &q = *static_cast<const exreq_empty_folder *>(q0);
	auto r1 = std::make_unique<exresp_empty_folder>();
	auto &r = *r1;
	auto ret = exmdb_server::empty_folder(q0->dir, q.cpid, q.username, q.folder_id, q.flags, &r.b_partial);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_folder_cycle: {
	auto &q = *static_cast<const exreq_check_folder_cycle *>(q0);
	auto r1 = std::make_unique<exresp_check_folder_cycle>();
	auto &r = *r1;
	auto ret = exmdb_server::check_folder_cycle(q0->dir, q.src_fid, q.dst_fid, &r.b_cycle);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::copy_folder_internal: {
	auto &q = *static_cast<const exreq_copy_folder_internal *>(q0);
	auto r1 = std::make_unique<exresp_copy_folder_internal>();
	auto &r = *r1;
	auto ret = exmdb_server::copy_folder_internal(q0->dir, q.account_id, q.cpid, q.b_guest, q.username, q.src_fid, q.b_normal, q.b_fai, q.b_sub, q.dst_fid, &r.b_collid, &r.b_partial);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_search_criteria: {
	auto &q = *static_cast<const exreq_get_search_criteria *>(q0);
	auto r1 = std::make_unique<exresp_get_search_criteria>();
	auto &r = *r1;
	auto ret = exmdb_server::get_search_criteria(q0->dir, q.folder_id, &r.search_status, &r.prestriction, &r.folder_ids);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_search_criteria: {
	auto &q = *static_cast<const exreq_set_search_criteria *>(q0);
	auto r1 = std::make_unique<exresp_set_search_criteria>();
	auto &r = *r1;
	auto ret = exmdb_server::set_search_criteria(q0->dir, q.cpid, q.folder_id, q.search_flags, q.prestriction, q.pfolder_ids, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::movecopy_message: {
	auto &q = *static_cast<const exreq_movecopy_message *>(q0);
	auto r1 = std::make_unique<exresp_movecopy_message>();
	auto &r = *r1;
	auto ret = exmdb_server::movecopy_message(q0->dir, q.account_id, q.cpid, q.message_id, q.dst_fid, q.dst_id, q.b_move, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::movecopy_messages: {
	auto &q = *static_cast<const exreq_movecopy_messages *>(q0);
	auto r1 = std::make_unique<exresp_movecopy_messages>();
	auto &r = *r1;
	auto ret = exmdb_server::movecopy_messages(q0->dir, q.account_id, q.cpid, q.b_guest, q.username, q.src_fid, q.dst_fid, q.b_copy, q.pmessage_ids, &r.b_partial);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::movecopy_folder: {
	auto &q = *static_cast<const exreq_movecopy_folder *>(q0);
	auto r1 = std::make_unique<exresp_movecopy_folder>();
	auto &r = *r1;
	auto ret = exmdb_server::movecopy_folder(q0->dir, q.account_id, q.cpid, q.b_guest, q.username, q.src_pid, q.src_fid, q.dst_fid, q.str_new, q.b_copy, &r.e_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::delete_messages: {
	auto &q = *static_cast<const exreq_delete_messages *>(q0);
	auto r1 = std::make_unique<exresp_delete_messages>();
	auto &r = *r1;
	auto ret = exmdb_server::delete_messages(q0->dir, q.account_id, q.cpid, q.username, q.folder_id, q.pmessage_ids, q.b_hard, &r.b_partial);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_brief: {
	auto &q = *static_cast<const exreq_get_message_brief *>(q0);
	auto r1 = std::make_unique<exresp_get_message_brief>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_brief(q0->dir, q.cpid, q.message_id, &r.pbrief);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::sum_hierarchy: {
	auto &q = *static_cast<const exreq_sum_hierarchy *>(q0);
	auto r1 = std::make_unique<exresp_sum_hierarchy>();
	auto &r = *r1;
	auto ret = exmdb_server::sum_hierarchy(q0->dir, q.folder_id, q.username, q.b_depth, &r.count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_hierarchy_table: {
	auto &q = *static_cast<const exreq_load_hierarchy_table *>(q0);
	auto r1 = std::make_unique<exresp_load_hierarchy_table>();
	auto &r = *r1;
	auto ret = exmdb_server::load_hierarchy_table(q0->dir, q.folder_id, q.username, q.table_flags, q.prestriction, &r.table_id, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::sum_content: {
	auto &q = *static_cast<const exreq_sum_content *>(q0);
	auto r1 = std::make_unique<exresp_sum_content>();
	auto &r = *r1;
	auto ret = exmdb_server::sum_content(q0->dir, q.folder_id, q.b_fai, q.b_deleted, &r.count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_content_table: {
	auto &q = *static_cast<const exreq_load_content_table *>(q0);
	auto r1 = std::make_unique<exresp_load_content_table>();
	auto &r = *r1;
	auto ret = exmdb_server::load_content_table(q0->dir, q.cpid, q.folder_id, q.username, q.table_flags, q.prestriction, q.psorts, &r.table_id, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::reload_content_table: {
	auto &q = *static_cast<const exreq_reload_content_table *>(q0);
	auto r1 = std::make_unique<exresp_reload_content_table>();
	auto ret = exmdb_server::reload_content_table(q0->dir, q.table_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_permission_table: {
	auto &q = *static_cast<const exreq_load_permission_table *>(q0);
	auto r1 = std::make_unique<exresp_load_permission_table>();
	auto &r = *r1;
	auto ret = exmdb_server::load_permission_table(q0->dir, q.folder_id, q.table_flags, &r.table_id, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_rule_table: {
	auto &q = *static_cast<const exreq_load_rule_table *>(q0);
	auto r1 = std::make_unique<exresp_load_rule_table>();
	auto &r = *r1;
	auto ret = exmdb_server::load_rule_table(q0->dir, q.folder_id, q.table_flags, q.prestriction, &r.table_id, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::unload_table: {
	auto &q = *static_cast<const exreq_unload_table *>(q0);
	auto r1 = std::make_unique<exresp_unload_table>();
	auto ret = exmdb_server::unload_table(q0->dir, q.table_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::sum_table: {
	auto &q = *static_cast<const exreq_sum_table *>(q0);
	auto r1 = std::make_unique<exresp_sum_table>();
	auto &r = *r1;
	auto ret = exmdb_server::sum_table(q0->dir, q.table_id, &r.rows);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::query_table: {
	auto &q = *static_cast<const exreq_query_table *>(q0);
	auto r1 = std::make_unique<exresp_query_table>();
	auto &r = *r1;
	auto ret = exmdb_server::query_table(q0->dir, q.username, q.cpid, q.table_id, q.pproptags, q.start_pos, q.row_needed, &r.set);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::match_table: {
	auto &q = *static_cast<const exreq_match_table *>(q0);
	auto r1 = std::make_unique<exresp_match_table>();
	auto &r = *r1;
	auto ret = exmdb_server::match_table(q0->dir, q.username, q.cpid, q.table_id, q.b_forward, q.start_pos, q.pres, q.pproptags, &r.position, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::locate_table: {
	auto &q = *static_cast<const exreq_locate_table *>(q0);
	auto r1 = std::make_unique<exresp_locate_table>();
	auto &r = *r1;
	auto ret = exmdb_server::locate_table(q0->dir, q.table_id, q.inst_id, q.inst_num, &r.position, &r.row_type);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::read_table_row: {
	auto &q = *static_cast<const exreq_read_table_row *>(q0);
	auto r1 = std::make_unique<exresp_read_table_row>();
	auto &r = *r1;
	auto ret = exmdb_server::read_table_row(q0->dir, q.username, q.cpid, q.table_id, q.pproptags, q.inst_id, q.inst_num, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::mark_table: {
	auto &q = *static_cast<const exreq_mark_table *>(q0);
	auto r1 = std::make_unique<exresp_mark_table>();
	auto &r = *r1;
	auto ret = exmdb_server::mark_table(q0->dir, q.table_id, q.position, &r.inst_id, &r.inst_num, &r.row_type);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_table_all_proptags: {
	auto &q = *static_cast<const exreq_get_table_all_proptags *>(q0);
	auto r1 = std::make_unique<exresp_get_table_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_table_all_proptags(q0->dir, q.table_id, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::expand_table: {
	auto &q = *static_cast<const exreq_expand_table *>(q0);
	auto r1 = std::make_unique<exresp_expand_table>();
	auto &r = *r1;
	auto ret = exmdb_server::expand_table(q0->dir, q.table_id, q.inst_id, &r.b_found, &r.position, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::collapse_table: {
	auto &q = *static_cast<const exreq_collapse_table *>(q0);
	auto r1 = std::make_unique<exresp_collapse_table>();
	auto &r = *r1;
	auto ret = exmdb_server::collapse_table(q0->dir, q.table_id, q.inst_id, &r.b_found, &r.position, &r.row_count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::store_table_state: {
	auto &q = *static_cast<const exreq_store_table_state *>(q0);
	auto r1 = std::make_unique<exresp_store_table_state>();
	auto &r = *r1;
	auto ret = exmdb_server::store_table_state(q0->dir, q.table_id, q.inst_id, q.inst_num, &r.state_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::restore_table_state: {
	auto &q = *static_cast<const exreq_restore_table_state *>(q0);
	auto r1 = std::make_unique<exresp_restore_table_state>();
	auto &r = *r1;
	auto ret = exmdb_server::restore_table_state(q0->dir, q.table_id, q.state_id, &r.position);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_message: {
	auto &q = *static_cast<const exreq_check_message *>(q0);
	auto r1 = std::make_unique<exresp_check_message>();
	auto &r = *r1;
	auto ret = exmdb_server::check_message(q0->dir, q.folder_id, q.message_id, &r.b_exist);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_message_deleted: {
	auto &q = *static_cast<const exreq_check_message_deleted *>(q0);
	auto r1 = std::make_unique<exresp_check_message_deleted>();
	auto &r = *r1;
	auto ret = exmdb_server::check_message_deleted(q0->dir, q.message_id, &r.b_del);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_message_instance: {
	auto &q = *static_cast<const exreq_load_message_instance *>(q0);
	auto r1 = std::make_unique<exresp_load_message_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::load_message_instance(q0->dir, q.username, q.cpid, q.b_new, q.folder_id, q.message_id, &r.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_embedded_instance: {
	auto &q = *static_cast<const exreq_load_embedded_instance *>(q0);
	auto r1 = std::make_unique<exresp_load_embedded_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::load_embedded_instance(q0->dir, q.b_new, q.attachment_instance_id, &r.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_embedded_cn: {
	auto &q = *static_cast<const exreq_get_embedded_cn *>(q0);
	auto r1 = std::make_unique<exresp_get_embedded_cn>();
	auto &r = *r1;
	auto ret = exmdb_server::get_embedded_cn(q0->dir, q.instance_id, &r.pcn);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::reload_message_instance: {
	auto &q = *static_cast<const exreq_reload_message_instance *>(q0);
	auto r1 = std::make_unique<exresp_reload_message_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::reload_message_instance(q0->dir, q.instance_id, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::clear_message_instance: {
	auto &q = *static_cast<const exreq_clear_message_instance *>(q0);
	auto r1 = std::make_unique<exresp_clear_message_instance>();
	auto ret = exmdb_server::clear_message_instance(q0->dir, q.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::read_message_instance: {
	auto &q = *static_cast<const exreq_read_message_instance *>(q0);
	auto r1 = std::make_unique<exresp_read_message_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::read_message_instance(q0->dir, q.instance_id, &r.msgctnt);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::write_message_instance: {
	auto &q = *static_cast<const exreq_write_message_instance *>(q0);
	auto r1 = std::make_unique<exresp_write_message_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::write_message_instance(q0->dir, q.instance_id, q.pmsgctnt, q.b_force, &r.proptags, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::load_attachment_instance: {
	auto &q = *static_cast<const exreq_load_attachment_instance *>(q0);
	auto r1 = std::make_unique<exresp_load_attachment_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::load_attachment_instance(q0->dir, q.message_instance_id, q.attachment_num, &r.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::create_attachment_instance: {
	auto &q = *static_cast<const exreq_create_attachment_instance *>(q0);
	auto r1 = std::make_unique<exresp_create_attachment_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::create_attachment_instance(q0->dir, q.message_instance_id, &r.instance_id, &r.attachment_num);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::read_attachment_instance: {
	auto &q = *static_cast<const exreq_read_attachment_instance *>(q0);
	auto r1 = std::make_unique<exresp_read_attachment_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::read_attachment_instance(q0->dir, q.instance_id, &r.attctnt);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::write_attachment_instance: {
	auto &q = *static_cast<const exreq_write_attachment_instance *>(q0);
	auto r1 = std::make_unique<exresp_write_attachment_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::write_attachment_instance(q0->dir, q.instance_id, q.pattctnt, q.b_force, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::delete_message_instance_attachment: {
	auto &q = *static_cast<const exreq_delete_message_instance_attachment *>(q0);
	auto r1 = std::make_unique<exresp_delete_message_instance_attachment>();
	auto ret = exmdb_server::delete_message_instance_attachment(q0->dir, q.message_instance_id, q.attachment_num);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::flush_instance: {
	auto &q = *static_cast<const exreq_flush_instance *>(q0);
	auto r1 = std::make_unique<exresp_flush_instance>();
	auto &r = *r1;
	auto ret = exmdb_server::flush_instance(q0->dir, q.instance_id, q.account, &r.e_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::unload_instance: {
	auto &q = *static_cast<const exreq_unload_instance *>(q0);
	auto r1 = std::make_unique<exresp_unload_instance>();
	auto ret = exmdb_server::unload_instance(q0->dir, q.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_instance_all_proptags: {
	auto &q = *static_cast<const exreq_get_instance_all_proptags *>(q0);
	auto r1 = std::make_unique<exresp_get_instance_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_instance_all_proptags(q0->dir, q.instance_id, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_instance_properties: {
	auto &q = *static_cast<const exreq_get_instance_properties *>(q0);
	auto r1 = std::make_unique<exresp_get_instance_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::get_instance_properties(q0->dir, q.size_limit, q.instance_id, q.pproptags, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_instance_properties: {
	auto &q = *static_cast<const exreq_set_instance_properties *>(q0);
	auto r1 = std::make_unique<exresp_set_instance_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::set_instance_properties(q0->dir, q.instance_id, q.pproperties, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::remove_instance_properties: {
	auto &q = *static_cast<const exreq_remove_instance_properties *>(q0);
	auto r1 = std::make_unique<exresp_remove_instance_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::remove_instance_properties(q0->dir, q.instance_id, q.pproptags, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_instance_cycle: {
	auto &q = *static_cast<const exreq_check_instance_cycle *>(q0);
	auto r1 = std::make_unique<exresp_check_instance_cycle>();
	auto &r = *r1;
	auto ret = exmdb_server::check_instance_cycle(q0->dir, q.src_instance_id, q.dst_instance_id, &r.b_cycle);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::empty_message_instance_rcpts: {
	auto &q = *static_cast<const exreq_empty_message_instance_rcpts *>(q0);
	auto r1 = std::make_unique<exresp_empty_message_instance_rcpts>();
	auto ret = exmdb_server::empty_message_instance_rcpts(q0->dir, q.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_instance_rcpts_num: {
	auto &q = *static_cast<const exreq_get_message_instance_rcpts_num *>(q0);
	auto r1 = std::make_unique<exresp_get_message_instance_rcpts_num>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_instance_rcpts_num(q0->dir, q.instance_id, &r.num);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_instance_rcpts_all_proptags: {
	auto &q = *static_cast<const exreq_get_message_instance_rcpts_all_proptags *>(q0);
	auto r1 = std::make_unique<exresp_get_message_instance_rcpts_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_instance_rcpts_all_proptags(q0->dir, q.instance_id, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_instance_rcpts: {
	auto &q = *static_cast<const exreq_get_message_instance_rcpts *>(q0);
	auto r1 = std::make_unique<exresp_get_message_instance_rcpts>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_instance_rcpts(q0->dir, q.instance_id, q.row_id, q.need_count, &r.set);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::update_message_instance_rcpts: {
	auto &q = *static_cast<const exreq_update_message_instance_rcpts *>(q0);
	auto r1 = std::make_unique<exresp_update_message_instance_rcpts>();
	auto ret = exmdb_server::update_message_instance_rcpts(q0->dir, q.instance_id, q.pset);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::copy_instance_rcpts: {
	auto &q = *static_cast<const exreq_copy_instance_rcpts *>(q0);
	auto r1 = std::make_unique<exresp_copy_instance_rcpts>();
	auto &r = *r1;
	auto ret = exmdb_server::copy_instance_rcpts(q0->dir, q.b_force, q.src_instance_id, q.dst_instance_id, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::empty_message_instance_attachments: {
	auto &q = *static_cast<const exreq_empty_message_instance_attachments *>(q0);
	auto r1 = std::make_unique<exresp_empty_message_instance_attachments>();
	auto ret = exmdb_server::empty_message_instance_attachments(q0->dir, q.instance_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_instance_attachments_num: {
	auto &q = *static_cast<const exreq_get_message_instance_attachments_num *>(q0);
	auto r1 = std::make_unique<exresp_get_message_instance_attachments_num>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_instance_attachments_num(q0->dir, q.instance_id, &r.num);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_instance_attachment_table_all_proptags: {
	auto &q = *static_cast<const exreq_get_message_instance_attachment_table_all_proptags *>(q0);
	auto r1 = std::make_unique<exresp_get_message_instance_attachment_table_all_proptags>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_instance_attachment_table_all_proptags(q0->dir, q.instance_id, &r.proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::query_message_instance_attachment_table: {
	auto &q = *static_cast<const exreq_query_message_instance_attachment_table *>(q0);
	auto r1 = std::make_unique<exresp_query_message_instance_attachment_table>();
	auto &r = *r1;
	auto ret = exmdb_server::query_message_instance_attachment_table(q0->dir, q.instance_id, q.pproptags, q.start_pos, q.row_needed, &r.set);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::copy_instance_attachments: {
	auto &q = *static_cast<const exreq_copy_instance_attachments *>(q0);
	auto r1 = std::make_unique<exresp_copy_instance_attachments>();
	auto &r = *r1;
	auto ret = exmdb_server::copy_instance_attachments(q0->dir, q.b_force, q.src_instance_id, q.dst_instance_id, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_message_instance_conflict: {
	auto &q = *static_cast<const exreq_set_message_instance_conflict *>(q0);
	auto r1 = std::make_unique<exresp_set_message_instance_conflict>();
	auto ret = exmdb_server::set_message_instance_conflict(q0->dir, q.instance_id, q.pmsgctnt);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_rcpts: {
	auto &q = *static_cast<const exreq_get_message_rcpts *>(q0);
	auto r1 = std::make_unique<exresp_get_message_rcpts>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_rcpts(q0->dir, q.message_id, &r.set);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_properties: {
	auto &q = *static_cast<const exreq_get_message_properties *>(q0);
	auto r1 = std::make_unique<exresp_get_message_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_properties(q0->dir, q.username, q.cpid, q.message_id, q.pproptags, &r.propvals);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_message_properties: {
	auto &q = *static_cast<const exreq_set_message_properties *>(q0);
	auto r1 = std::make_unique<exresp_set_message_properties>();
	auto &r = *r1;
	auto ret = exmdb_server::set_message_properties(q0->dir, q.username, q.cpid, q.message_id, q.pproperties, &r.problems);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_message_read_state: {
	auto &q = *static_cast<const exreq_set_message_read_state *>(q0);
	auto r1 = std::make_unique<exresp_set_message_read_state>();
	auto &r = *r1;
	auto ret = exmdb_server::set_message_read_state(q0->dir, q.username, q.message_id, q.mark_as_read, &r.read_cn);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::remove_message_properties: {
	auto &q = *static_cast<const exreq_remove_message_properties *>(q0);
	auto r1 = std::make_unique<exresp_remove_message_properties>();
	auto ret = exmdb_server::remove_message_properties(q0->dir, q.cpid, q.message_id, q.pproptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::allocate_message_id: {
	auto &q = *static_cast<const exreq_allocate_message_id *>(q0);
	auto r1 = std::make_unique<exresp_allocate_message_id>();
	auto &r = *r1;
	auto ret = exmdb_server::allocate_message_id(q0->dir, q.folder_id, &r.message_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::allocate_cn: {
	auto r1 = std::make_unique<exresp_allocate_cn>();
	auto &r = *r1;
	auto ret = exmdb_server::allocate_cn(q0->dir, &r.cn);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_group_id: {
	auto &q = *static_cast<const exreq_get_message_group_id *>(q0);
	auto r1 = std::make_unique<exresp_get_message_group_id>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_group_id(q0->dir, q.message_id, &r.pgroup_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_message_group_id: {
	auto &q = *static_cast<const exreq_set_message_group_id *>(q0);
	auto r1 = std::make_unique<exresp_set_message_group_id>();
	auto ret = exmdb_server::set_message_group_id(q0->dir, q.message_id, q.group_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::save_change_indices: {
	auto &q = *static_cast<const exreq_save_change_indices *>(q0);
	auto r1 = std::make_unique<exresp_save_change_indices>();
	auto ret = exmdb_server::save_change_indices(q0->dir, q.message_id, q.cn, q.pindices, q.pungroup_proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_change_indices: {
	auto &q = *static_cast<const exreq_get_change_indices *>(q0);
	auto r1 = std::make_unique<exresp_get_change_indices>();
	auto &r = *r1;
	auto ret = exmdb_server::get_change_indices(q0->dir, q.message_id, q.cn, &r.indices, &r.ungroup_proptags);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::mark_modified: {
	auto &q = *static_cast<const exreq_mark_modified *>(q0);
	auto r1 = std::make_unique<exresp_mark_modified>();
	auto ret = exmdb_server::mark_modified(q0->dir, q.message_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::try_mark_submit: {
	auto &q = *static_cast<const exreq_try_mark_submit *>(q0);
	auto r1 = std::make_unique<exresp_try_mark_submit>();
	auto &r = *r1;
	auto ret = exmdb_server::try_mark_submit(q0->dir, q.message_id, &r.b_marked);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::clear_submit: {
	auto &q = *static_cast<const exreq_clear_submit *>(q0);
	auto r1 = std::make_unique<exresp_clear_submit>();
	auto ret = exmdb_server::clear_submit(q0->dir, q.message_id, q.b_unsent);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::link_message: {
	auto &q = *static_cast<const exreq_link_message *>(q0);
	auto r1 = std::make_unique<exresp_link_message>();
	auto &r = *r1;
	auto ret = exmdb_server::link_message(q0->dir, q.cpid, q.folder_id, q.message_id, &r.b_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::unlink_message: {
	auto &q = *static_cast<const exreq_unlink_message *>(q0);
	auto r1 = std::make_unique<exresp_unlink_message>();
	auto ret = exmdb_server::unlink_message(q0->dir, q.cpid, q.folder_id, q.message_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::rule_new_message: {
	auto &q = *static_cast<const exreq_rule_new_message *>(q0);
	auto r1 = std::make_unique<exresp_rule_new_message>();
	auto ret = exmdb_server::rule_new_message(q0->dir, q.username, q.account, q.cpid, q.folder_id, q.message_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::set_message_timer: {
	auto &q = *static_cast<const exreq_set_message_timer *>(q0);
	auto r1 = std::make_unique<exresp_set_message_timer>();
	auto ret = exmdb_server::set_message_timer(q0->dir, q.message_id, q.timer_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_message_timer: {
	auto &q = *static_cast<const exreq_get_message_timer *>(q0);
	auto r1 = std::make_unique<exresp_get_message_timer>();
	auto &r = *r1;
	auto ret = exmdb_server::get_message_timer(q0->dir, q.message_id, &r.ptimer_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::empty_folder_permission: {
	auto &q = *static_cast<const exreq_empty_folder_permission *>(q0);
	auto r1 = std::make_unique<exresp_empty_folder_permission>();
	auto ret = exmdb_server::empty_folder_permission(q0->dir, q.folder_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::update_folder_permission: {
	auto &q = *static_cast<const exreq_update_folder_permission *>(q0);
	auto r1 = std::make_unique<exresp_update_folder_permission>();
	auto ret = exmdb_server::update_folder_permission(q0->dir, q.folder_id, q.b_freebusy, q.count, q.prow);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::empty_folder_rule: {
	auto &q = *static_cast<const exreq_empty_folder_rule *>(q0);
	auto r1 = std::make_unique<exresp_empty_folder_rule>();
	auto ret = exmdb_server::empty_folder_rule(q0->dir, q.folder_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::update_folder_rule: {
	auto &q = *static_cast<const exreq_update_folder_rule *>(q0);
	auto r1 = std::make_unique<exresp_update_folder_rule>();
	auto &r = *r1;
	auto ret = exmdb_server::update_folder_rule(q0->dir, q.folder_id, q.count, q.prow, &r.b_exceed);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::deliver_message: {
	auto &q = *static_cast<const exreq_deliver_message *>(q0);
	auto r1 = std::make_unique<exresp_deliver_message>();
	auto &r = *r1;
	auto ret = exmdb_server::deliver_message(q0->dir, q.from_address, q.account, q.cpid, q.dlflags, q.pmsg, q.pdigest, &r.folder_id, &r.message_id, &r.result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::write_message: {
	auto &q = *static_cast<const exreq_write_message *>(q0);
	auto r1 = std::make_unique<exresp_write_message>();
	auto &r = *r1;
	auto ret = exmdb_server::write_message(q0->dir, q.account, q.cpid, q.folder_id, q.pmsgctnt, &r.e_result);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::read_message: {
	auto &q = *static_cast<const exreq_read_message *>(q0);
	auto r1 = std::make_unique<exresp_read_message>();
	auto &r = *r1;
	auto ret = exmdb_server::read_message(q0->dir, q.username, q.cpid, q.message_id, &r.pmsgctnt);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_content_sync: {
	auto &q = *static_cast<const exreq_get_content_sync *>(q0);
	auto r1 = std::make_unique<exresp_get_content_sync>();
	auto &r = *r1;
	auto ret = exmdb_server::get_content_sync(q0->dir, q.folder_id, q.username, q.pgiven, q.pseen, q.pseen_fai, q.pread, q.cpid, q.prestriction, q.b_ordered, &r.fai_count, &r.fai_total, &r.normal_count, &r.normal_total, &r.updated_mids, &r.chg_mids, &r.last_cn, &r.given_mids, &r.deleted_mids, &r.nolonger_mids, &r.read_mids, &r.unread_mids, &r.last_readcn);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_hierarchy_sync: {
	auto &q = *static_cast<const exreq_get_hierarchy_sync *>(q0);
	auto r1 = std::make_unique<exresp_get_hierarchy_sync>();
	auto &r = *r1;
	auto ret = exmdb_server::get_hierarchy_sync(q0->dir, q.folder_id, q.username, q.pgiven, q.pseen, &r.fldchgs, &r.last_cn, &r.given_fids, &r.deleted_fids);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::allocate_ids: {
	auto &q = *static_cast<const exreq_allocate_ids *>(q0);
	auto r1 = std::make_unique<exresp_allocate_ids>();
	auto &r = *r1;
	auto ret = exmdb_server::allocate_ids(q0->dir, q.count, &r.begin_eid);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::subscribe_notification: {
	auto &q = *static_cast<const exreq_subscribe_notification *>(q0);
	auto r1 = std::make_unique<exresp_subscribe_notification>();
	auto &r = *r1;
	auto ret = exmdb_server::subscribe_notification(q0->dir, q.notification_type, q.b_whole, q.folder_id, q.message_id, &r.sub_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::unsubscribe_notification: {
	auto &q = *static_cast<const exreq_unsubscribe_notification *>(q0);
	auto r1 = std::make_unique<exresp_unsubscribe_notification>();
	auto ret = exmdb_server::unsubscribe_notification(q0->dir, q.sub_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::transport_new_mail: {
	auto &q = *static_cast<const exreq_transport_new_mail *>(q0);
	auto r1 = std::make_unique<exresp_transport_new_mail>();
	auto ret = exmdb_server::transport_new_mail(q0->dir, q.folder_id, q.message_id, q.message_flags, q.pstr_class);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::check_contact_address: {
	auto &q = *static_cast<const exreq_check_contact_address *>(q0);
	auto r1 = std::make_unique<exresp_check_contact_address>();
	auto &r = *r1;
	auto ret = exmdb_server::check_contact_address(q0->dir, q.paddress, &r.b_found);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::get_public_folder_unread_count: {
	auto &q = *static_cast<const exreq_get_public_folder_unread_count *>(q0);
	auto r1 = std::make_unique<exresp_get_public_folder_unread_count>();
	auto &r = *r1;
	auto ret = exmdb_server::get_public_folder_unread_count(q0->dir, q.username, q.folder_id, &r.count);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::vacuum: {
	auto r1 = std::make_unique<exresp_vacuum>();
	auto ret = exmdb_server::vacuum(q0->dir);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::unload_store: {
	auto r1 = std::make_unique<exresp_unload_store>();
	auto ret = exmdb_server::unload_store(q0->dir);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::notify_new_mail: {
	auto &q = *static_cast<const exreq_notify_new_mail *>(q0);
	auto r1 = std::make_unique<exresp_notify_new_mail>();
	auto ret = exmdb_server::notify_new_mail(q0->dir, q.folder_id, q.message_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::store_eid_to_user: {
	auto &q = *static_cast<const exreq_store_eid_to_user *>(q0);
	auto r1 = std::make_unique<exresp_store_eid_to_user>();
	auto &r = *r1;
	auto ret = exmdb_server::store_eid_to_user(q0->dir, q.store_eid, &r.maildir, &r.user_id, &r.domain_id);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::purge_softdelete: {
	auto &q = *static_cast<const exreq_purge_softdelete *>(q0);
	auto r1 = std::make_unique<exresp_purge_softdelete>();
	auto ret = exmdb_server::purge_softdelete(q0->dir, q.username, q.folder_id, q.del_flags, q.cutoff);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::purge_datafiles: {
	auto r1 = std::make_unique<exresp_purge_datafiles>();
	auto ret = exmdb_server::purge_datafiles(q0->dir);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::autoreply_tsquery: {
	auto &q = *static_cast<const exreq_autoreply_tsquery *>(q0);
	auto r1 = std::make_unique<exresp_autoreply_tsquery>();
	auto &r = *r1;
	auto ret = exmdb_server::autoreply_tsquery(q0->dir, q.peer, q.window, &r.tdiff);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::autoreply_tsupdate: {
	auto &q = *static_cast<const exreq_autoreply_tsupdate *>(q0);
	auto r1 = std::make_unique<exresp_autoreply_tsupdate>();
	auto ret = exmdb_server::autoreply_tsupdate(q0->dir, q.peer);
	r0 = std::move(r1);
	return ret;
}
case exmdb_callid::recalc_store_size: {
	auto &q = *static_cast<const exreq_recalc_store_size *>(q0);
	auto r1 = std::make_unique<exresp_recalc_store_size>();
	auto ret = exmdb_server::recalc_store_size(q0->dir, q.flags);
	r0 = std::move(r1);
	return ret;
}
